summaryrefslogtreecommitdiffstats
path: root/tests/lib
diff options
context:
space:
mode:
authorCarlos Goncalves <carlos.goncalves@neclab.eu>2016-11-30 13:08:20 +0000
committerCarlos Goncalves <carlos.goncalves@neclab.eu>2016-12-14 16:12:13 +0000
commit18651c07b942abf0060e6478758050dd365619eb (patch)
tree201428ea4fc2a2f1eeb2e5dda0ffd5f0b050a904 /tests/lib
parent40cba233d16e355b078e368772ad4aadbb5f91b1 (diff)
Refactor inspectors support code
JIRA: DOCTOR-71 Change-Id: I0913d4d0390325cc0cc715572b7525a6bbb795d3 Signed-off-by: Carlos Goncalves <carlos.goncalves@neclab.eu>
Diffstat (limited to 'tests/lib')
-rw-r--r--tests/lib/inspector30
-rw-r--r--tests/lib/inspectors/congress69
-rw-r--r--tests/lib/inspectors/sample16
3 files changed, 115 insertions, 0 deletions
diff --git a/tests/lib/inspector b/tests/lib/inspector
new file mode 100644
index 00000000..2fb7c409
--- /dev/null
+++ b/tests/lib/inspector
@@ -0,0 +1,30 @@
+#!/bin/bash
+
+INSPECTOR_TYPE=${INSPECTOR_TYPE:-sample}
+
+function is_inspector_supported {
+ local inspector="$1"
+ [[ -f $TOP_DIR/lib/inspectors/$inspector ]]
+}
+
+function is_inspector {
+ local inspector="$1"
+ [[ $inspector == $INSPECTOR_TYPE ]]
+}
+
+function start_inspector {
+ if ! is_inspector_supported $INSPECTOR_TYPE; then
+ die $LINENO"INSPECTOR_TYPE=$INSPECTOR_TYPE is not supported."
+ fi
+
+ source $TOP_DIR/lib/inspectors/$INSPECTOR_TYPE
+ start_inspector_$INSPECTOR_TYPE
+}
+
+function stop_inspector {
+ stop_inspector_$INSPECTOR_TYPE
+}
+
+function cleanup_inspector {
+ cleanup_inspector_$INSPECTOR_TYPE
+}
diff --git a/tests/lib/inspectors/congress b/tests/lib/inspectors/congress
new file mode 100644
index 00000000..04825252
--- /dev/null
+++ b/tests/lib/inspectors/congress
@@ -0,0 +1,69 @@
+#!/bin/bash
+
+function _congress_add_rule {
+ name=$1
+ policy=$2
+ rule=$3
+
+ if ! openstack congress policy rule list $policy | grep -q -e "// Name: $name$" ; then
+ openstack congress policy rule create --name $name $policy "$rule"
+ fi
+}
+
+function _congress_del_rule {
+ name=$1
+ policy=$2
+
+ if openstack congress policy rule list $policy | grep -q -e "^// Name: $name$" ; then
+ openstack congress policy rule delete $policy $name
+ fi
+}
+
+function _congress_add_rules {
+ _congress_add_rule host_down classification \
+ 'host_down(host) :-
+ doctor:events(hostname=host, type="compute.host.down", status="down")'
+
+ _congress_add_rule active_instance_in_host classification \
+ 'active_instance_in_host(vmid, host) :-
+ nova:servers(id=vmid, host_name=host, status="ACTIVE")'
+
+ _congress_add_rule host_force_down classification \
+ 'execute[nova:services.force_down(host, "nova-compute", "True")] :-
+ host_down(host)'
+
+ _congress_add_rule error_vm_states classification \
+ 'execute[nova:servers.reset_state(vmid, "error")] :-
+ host_down(host),
+ active_instance_in_host(vmid, host)'
+}
+
+function start_inspector_congress {
+ nova_api_min_version="2.11"
+ nova_api_version=$(openstack congress datasource list | \
+ grep nova | grep -Po "(?<='api_version': ')[^']*")
+ [[ -z $nova_api_version ]] && nova_api_version="2.0"
+ if [[ "$nova_api_version" < "$nova_api_min_version" ]]; then
+ echo "ERROR: Congress Nova datasource API version < $nova_api_min_version ($nova_api_version)"
+ exit 1
+ fi
+ openstack congress driver list | grep -q " doctor "
+ openstack congress datasource list | grep -q " doctor " || {
+ openstack congress datasource create doctor doctor
+ }
+ _congress_add_rules
+
+}
+
+function stop_inspector_congress {
+ _congress_del_rule host_force_down classification
+ _congress_del_rule error_vm_states classification
+ _congress_del_rule active_instance_in_host classification
+ _congress_del_rule host_down classification
+
+}
+
+function cleanup_inspector_congress {
+ # Noop
+ return
+}
diff --git a/tests/lib/inspectors/sample b/tests/lib/inspectors/sample
new file mode 100644
index 00000000..cd21a008
--- /dev/null
+++ b/tests/lib/inspectors/sample
@@ -0,0 +1,16 @@
+#!/bin/bash
+
+function start_inspector_sample {
+ pgrep -f "python inspector.py" && return 0
+ python inspector.py "$INSPECTOR_PORT" > inspector.log 2>&1 &
+}
+
+function stop_inspector_sample {
+ pgrep -f "python inspector.py" || return 0
+ kill $(pgrep -f "python inspector.py")
+}
+
+function cleanup_inspector_sample {
+ # Noop
+ return
+}